Merge branch 'ab/checkout-default-remote'
[git.git] / git-submodule.sh
blobf7fd80345cd991df4b17c6598d7dd7bd462424c7
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
17 OPTIONS_SPEC=
18 SUBDIRECTORY_OK=Yes
19 . git-sh-setup
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
25 # Tell the rest of git that any URLs we get don't come
26 # directly from the user, so it can apply policy as appropriate.
27 GIT_PROTOCOL_FROM_USER=0
28 export GIT_PROTOCOL_FROM_USER
30 command=
31 branch=
32 force=
33 reference=
34 cached=
35 recursive=
36 init=
37 files=
38 remote=
39 nofetch=
40 update=
41 prefix=
42 custom_name=
43 depth=
44 progress=
45 dissociate=
47 die_if_unmatched ()
49 if test "$1" = "#unmatched"
50 then
51 exit ${2:-1}
56 # Print a submodule configuration setting
58 # $1 = submodule name
59 # $2 = option name
60 # $3 = default value
62 # Checks in the usual git-config places first (for overrides),
63 # otherwise it falls back on .gitmodules. This allows you to
64 # distribute project-wide defaults in .gitmodules, while still
65 # customizing individual repositories if necessary. If the option is
66 # not in .gitmodules either, print a default value.
68 get_submodule_config () {
69 name="$1"
70 option="$2"
71 default="$3"
72 value=$(git config submodule."$name"."$option")
73 if test -z "$value"
74 then
75 value=$(git config -f .gitmodules submodule."$name"."$option")
77 printf '%s' "${value:-$default}"
80 isnumber()
82 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
85 # Sanitize the local git environment for use within a submodule. We
86 # can't simply use clear_local_git_env since we want to preserve some
87 # of the settings from GIT_CONFIG_PARAMETERS.
88 sanitize_submodule_env()
90 save_config=$GIT_CONFIG_PARAMETERS
91 clear_local_git_env
92 GIT_CONFIG_PARAMETERS=$save_config
93 export GIT_CONFIG_PARAMETERS
97 # Add a new submodule to the working tree, .gitmodules and the index
99 # $@ = repo path
101 # optional branch is stored in global branch variable
103 cmd_add()
105 # parse $args after "submodule ... add".
106 reference_path=
107 while test $# -ne 0
109 case "$1" in
110 -b | --branch)
111 case "$2" in '') usage ;; esac
112 branch=$2
113 shift
115 -f | --force)
116 force=$1
118 -q|--quiet)
119 GIT_QUIET=1
121 --progress)
122 progress=1
124 --reference)
125 case "$2" in '') usage ;; esac
126 reference_path=$2
127 shift
129 --reference=*)
130 reference_path="${1#--reference=}"
132 --dissociate)
133 dissociate=1
135 --name)
136 case "$2" in '') usage ;; esac
137 custom_name=$2
138 shift
140 --depth)
141 case "$2" in '') usage ;; esac
142 depth="--depth=$2"
143 shift
145 --depth=*)
146 depth=$1
149 shift
150 break
153 usage
156 break
158 esac
159 shift
160 done
162 if test -n "$reference_path"
163 then
164 is_absolute_path "$reference_path" ||
165 reference_path="$wt_prefix$reference_path"
167 reference="--reference=$reference_path"
170 repo=$1
171 sm_path=$2
173 if test -z "$sm_path"; then
174 sm_path=$(printf '%s\n' "$repo" |
175 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
178 if test -z "$repo" || test -z "$sm_path"; then
179 usage
182 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
184 # assure repo is absolute or relative to parent
185 case "$repo" in
186 ./*|../*)
187 test -z "$wt_prefix" ||
188 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
190 # dereference source url relative to parent's url
191 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
193 *:*|/*)
194 # absolute url
195 realrepo=$repo
198 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
200 esac
202 # normalize path:
203 # multiple //; leading ./; /./; /../; trailing /
204 sm_path=$(printf '%s/\n' "$sm_path" |
205 sed -e '
206 s|//*|/|g
207 s|^\(\./\)*||
208 s|/\(\./\)*|/|g
209 :start
210 s|\([^/]*\)/\.\./||
211 tstart
212 s|/*$||
214 if test -z "$force"
215 then
216 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
217 die "$(eval_gettext "'\$sm_path' already exists in the index")"
218 else
219 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
220 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
223 if test -z "$force" &&
224 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
225 then
226 eval_gettextln "The following path is ignored by one of your .gitignore files:
227 \$sm_path
228 Use -f if you really want to add it." >&2
229 exit 1
232 if test -n "$custom_name"
233 then
234 sm_name="$custom_name"
235 else
236 sm_name="$sm_path"
239 if ! git submodule--helper check-name "$sm_name"
240 then
241 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
244 # perhaps the path exists and is already a git repo, else clone it
245 if test -e "$sm_path"
246 then
247 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
248 then
249 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
250 else
251 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
254 else
255 if test -d ".git/modules/$sm_name"
256 then
257 if test -z "$force"
258 then
259 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
260 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
261 die "$(eval_gettextln "\
262 If you want to reuse this local git directory instead of cloning again from
263 \$realrepo
264 use the '--force' option. If the local git directory is not the correct repo
265 or you are unsure what this means choose another name with the '--name' option.")"
266 else
267 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
270 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
272 sanitize_submodule_env
273 cd "$sm_path" &&
274 # ash fails to wordsplit ${branch:+-b "$branch"...}
275 case "$branch" in
276 '') git checkout -f -q ;;
277 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
278 esac
279 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
281 git config submodule."$sm_name".url "$realrepo"
283 git add --no-warn-embedded-repo $force "$sm_path" ||
284 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
286 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
287 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
288 if test -n "$branch"
289 then
290 git config -f .gitmodules submodule."$sm_name".branch "$branch"
291 fi &&
292 git add --force .gitmodules ||
293 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
295 # NEEDSWORK: In a multi-working-tree world, this needs to be
296 # set in the per-worktree config.
297 if git config --get submodule.active >/dev/null
298 then
299 # If the submodule being adding isn't already covered by the
300 # current configured pathspec, set the submodule's active flag
301 if ! git submodule--helper is-active "$sm_path"
302 then
303 git config submodule."$sm_name".active "true"
305 else
306 git config submodule."$sm_name".active "true"
311 # Execute an arbitrary command sequence in each checked out
312 # submodule
314 # $@ = command to execute
316 cmd_foreach()
318 # parse $args after "submodule ... foreach".
319 while test $# -ne 0
321 case "$1" in
322 -q|--quiet)
323 GIT_QUIET=1
325 --recursive)
326 recursive=1
329 usage
332 break
334 esac
335 shift
336 done
338 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
342 # Register submodules in .git/config
344 # $@ = requested paths (default to all)
346 cmd_init()
348 # parse $args after "submodule ... init".
349 while test $# -ne 0
351 case "$1" in
352 -q|--quiet)
353 GIT_QUIET=1
356 shift
357 break
360 usage
363 break
365 esac
366 shift
367 done
369 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
373 # Unregister submodules from .git/config and remove their work tree
375 cmd_deinit()
377 # parse $args after "submodule ... deinit".
378 deinit_all=
379 while test $# -ne 0
381 case "$1" in
382 -f|--force)
383 force=$1
385 -q|--quiet)
386 GIT_QUIET=1
388 --all)
389 deinit_all=t
392 shift
393 break
396 usage
399 break
401 esac
402 shift
403 done
405 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
408 is_tip_reachable () (
409 sanitize_submodule_env &&
410 cd "$1" &&
411 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
412 test -z "$rev"
415 fetch_in_submodule () (
416 sanitize_submodule_env &&
417 cd "$1" &&
418 case "$2" in
420 git fetch ;;
422 shift
423 git fetch $(get_default_remote) "$@" ;;
424 esac
428 # Update each submodule path to correct revision, using clone and checkout as needed
430 # $@ = requested paths (default to all)
432 cmd_update()
434 # parse $args after "submodule ... update".
435 while test $# -ne 0
437 case "$1" in
438 -q|--quiet)
439 GIT_QUIET=1
442 GIT_QUIET=0
444 --progress)
445 progress=1
447 -i|--init)
448 init=1
450 --remote)
451 remote=1
453 -N|--no-fetch)
454 nofetch=1
456 -f|--force)
457 force=$1
459 -r|--rebase)
460 update="rebase"
462 --reference)
463 case "$2" in '') usage ;; esac
464 reference="--reference=$2"
465 shift
467 --reference=*)
468 reference="$1"
470 --dissociate)
471 dissociate=1
473 -m|--merge)
474 update="merge"
476 --recursive)
477 recursive=1
479 --checkout)
480 update="checkout"
482 --recommend-shallow)
483 recommend_shallow="--recommend-shallow"
485 --no-recommend-shallow)
486 recommend_shallow="--no-recommend-shallow"
488 --depth)
489 case "$2" in '') usage ;; esac
490 depth="--depth=$2"
491 shift
493 --depth=*)
494 depth=$1
496 -j|--jobs)
497 case "$2" in '') usage ;; esac
498 jobs="--jobs=$2"
499 shift
501 --jobs=*)
502 jobs=$1
505 shift
506 break
509 usage
512 break
514 esac
515 shift
516 done
518 if test -n "$init"
519 then
520 cmd_init "--" "$@" || return
524 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
525 ${progress:+"--progress"} \
526 ${wt_prefix:+--prefix "$wt_prefix"} \
527 ${prefix:+--recursive-prefix "$prefix"} \
528 ${update:+--update "$update"} \
529 ${reference:+"$reference"} \
530 ${dissociate:+"--dissociate"} \
531 ${depth:+--depth "$depth"} \
532 $recommend_shallow \
533 $jobs \
534 "$@" || echo "#unmatched" $?
535 } | {
536 err=
537 while read -r mode sha1 stage just_cloned sm_path
539 die_if_unmatched "$mode" "$sha1"
541 name=$(git submodule--helper name "$sm_path") || exit
542 if ! test -z "$update"
543 then
544 update_module=$update
545 else
546 update_module=$(git config submodule."$name".update)
547 if test -z "$update_module"
548 then
549 update_module="checkout"
553 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
555 if test $just_cloned -eq 1
556 then
557 subsha1=
558 case "$update_module" in
559 merge | rebase | none)
560 update_module=checkout ;;
561 esac
562 else
563 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
564 git rev-parse --verify HEAD) ||
565 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
568 if test -n "$remote"
569 then
570 branch=$(git submodule--helper remote-branch "$sm_path")
571 if test -z "$nofetch"
572 then
573 # Fetch remote before determining tracking $sha1
574 fetch_in_submodule "$sm_path" $depth ||
575 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
577 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
578 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
579 git rev-parse --verify "${remote_name}/${branch}") ||
580 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
583 if ! $(git config -f "$(git rev-parse --git-common-dir)/modules/$name/config" core.worktree) 2>/dev/null
584 then
585 git submodule--helper connect-gitdir-workingtree "$name" "$sm_path"
588 if test "$subsha1" != "$sha1" || test -n "$force"
589 then
590 subforce=$force
591 # If we don't already have a -f flag and the submodule has never been checked out
592 if test -z "$subsha1" && test -z "$force"
593 then
594 subforce="-f"
597 if test -z "$nofetch"
598 then
599 # Run fetch only if $sha1 isn't present or it
600 # is not reachable from a ref.
601 is_tip_reachable "$sm_path" "$sha1" ||
602 fetch_in_submodule "$sm_path" $depth ||
603 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
605 # Now we tried the usual fetch, but $sha1 may
606 # not be reachable from any of the refs
607 is_tip_reachable "$sm_path" "$sha1" ||
608 fetch_in_submodule "$sm_path" $depth "$sha1" ||
609 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
612 must_die_on_failure=
613 case "$update_module" in
614 checkout)
615 command="git checkout $subforce -q"
616 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
617 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
619 rebase)
620 command="git rebase"
621 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
622 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
623 must_die_on_failure=yes
625 merge)
626 command="git merge"
627 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
628 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
629 must_die_on_failure=yes
632 command="${update_module#!}"
633 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
634 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
635 must_die_on_failure=yes
638 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
639 esac
641 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
642 then
643 say "$say_msg"
644 elif test -n "$must_die_on_failure"
645 then
646 die_with_status 2 "$die_msg"
647 else
648 err="${err};$die_msg"
649 continue
653 if test -n "$recursive"
654 then
656 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
657 wt_prefix=
658 sanitize_submodule_env
659 cd "$sm_path" &&
660 eval cmd_update
662 res=$?
663 if test $res -gt 0
664 then
665 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
666 if test $res -ne 2
667 then
668 err="${err};$die_msg"
669 continue
670 else
671 die_with_status $res "$die_msg"
675 done
677 if test -n "$err"
678 then
679 OIFS=$IFS
680 IFS=';'
681 for e in $err
683 if test -n "$e"
684 then
685 echo >&2 "$e"
687 done
688 IFS=$OIFS
689 exit 1
695 # Show commit summary for submodules in index or working tree
697 # If '--cached' is given, show summary between index and given commit,
698 # or between working tree and given commit
700 # $@ = [commit (default 'HEAD'),] requested paths (default all)
702 cmd_summary() {
703 summary_limit=-1
704 for_status=
705 diff_cmd=diff-index
707 # parse $args after "submodule ... summary".
708 while test $# -ne 0
710 case "$1" in
711 --cached)
712 cached="$1"
714 --files)
715 files="$1"
717 --for-status)
718 for_status="$1"
720 -n|--summary-limit)
721 summary_limit="$2"
722 isnumber "$summary_limit" || usage
723 shift
725 --summary-limit=*)
726 summary_limit="${1#--summary-limit=}"
727 isnumber "$summary_limit" || usage
730 shift
731 break
734 usage
737 break
739 esac
740 shift
741 done
743 test $summary_limit = 0 && return
745 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
746 then
747 head=$rev
748 test $# = 0 || shift
749 elif test -z "$1" || test "$1" = "HEAD"
750 then
751 # before the first commit: compare with an empty tree
752 head=$(git hash-object -w -t tree --stdin </dev/null)
753 test -z "$1" || shift
754 else
755 head="HEAD"
758 if [ -n "$files" ]
759 then
760 test -n "$cached" &&
761 die "$(gettext "The --cached option cannot be used with the --files option")"
762 diff_cmd=diff-files
763 head=
766 cd_to_toplevel
767 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
768 # Get modified modules cared by user
769 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
770 sane_egrep '^:([0-7]* )?160000' |
771 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
773 # Always show modules deleted or type-changed (blob<->module)
774 if test "$status" = D || test "$status" = T
775 then
776 printf '%s\n' "$sm_path"
777 continue
779 # Respect the ignore setting for --for-status.
780 if test -n "$for_status"
781 then
782 name=$(git submodule--helper name "$sm_path")
783 ignore_config=$(get_submodule_config "$name" ignore none)
784 test $status != A && test $ignore_config = all && continue
786 # Also show added or modified modules which are checked out
787 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
788 printf '%s\n' "$sm_path"
789 done
792 test -z "$modules" && return
794 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
795 sane_egrep '^:([0-7]* )?160000' |
796 cut -c2- |
797 while read -r mod_src mod_dst sha1_src sha1_dst status name
799 if test -z "$cached" &&
800 test $sha1_dst = 0000000000000000000000000000000000000000
801 then
802 case "$mod_dst" in
803 160000)
804 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
806 100644 | 100755 | 120000)
807 sha1_dst=$(git hash-object $name)
809 000000)
810 ;; # removed
812 # unexpected type
813 eval_gettextln "unexpected mode \$mod_dst" >&2
814 continue ;;
815 esac
817 missing_src=
818 missing_dst=
820 test $mod_src = 160000 &&
821 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
822 missing_src=t
824 test $mod_dst = 160000 &&
825 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
826 missing_dst=t
828 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
830 total_commits=
831 case "$missing_src,$missing_dst" in
833 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
836 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
838 t,t)
839 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
842 errmsg=
843 total_commits=$(
844 if test $mod_src = 160000 && test $mod_dst = 160000
845 then
846 range="$sha1_src...$sha1_dst"
847 elif test $mod_src = 160000
848 then
849 range=$sha1_src
850 else
851 range=$sha1_dst
853 GIT_DIR="$name/.git" \
854 git rev-list --first-parent $range -- | wc -l
856 total_commits=" ($(($total_commits + 0)))"
858 esac
860 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
861 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
862 if test $status = T
863 then
864 blob="$(gettext "blob")"
865 submodule="$(gettext "submodule")"
866 if test $mod_dst = 160000
867 then
868 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
869 else
870 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
872 else
873 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
875 if test -n "$errmsg"
876 then
877 # Don't give error msg for modification whose dst is not submodule
878 # i.e. deleted or changed to blob
879 test $mod_dst = 160000 && echo "$errmsg"
880 else
881 if test $mod_src = 160000 && test $mod_dst = 160000
882 then
883 limit=
884 test $summary_limit -gt 0 && limit="-$summary_limit"
885 GIT_DIR="$name/.git" \
886 git log $limit --pretty='format: %m %s' \
887 --first-parent $sha1_src...$sha1_dst
888 elif test $mod_dst = 160000
889 then
890 GIT_DIR="$name/.git" \
891 git log --pretty='format: > %s' -1 $sha1_dst
892 else
893 GIT_DIR="$name/.git" \
894 git log --pretty='format: < %s' -1 $sha1_src
896 echo
898 echo
899 done
902 # List all submodules, prefixed with:
903 # - submodule not initialized
904 # + different revision checked out
906 # If --cached was specified the revision in the index will be printed
907 # instead of the currently checked out revision.
909 # $@ = requested paths (default to all)
911 cmd_status()
913 # parse $args after "submodule ... status".
914 while test $# -ne 0
916 case "$1" in
917 -q|--quiet)
918 GIT_QUIET=1
920 --cached)
921 cached=1
923 --recursive)
924 recursive=1
927 shift
928 break
931 usage
934 break
936 esac
937 shift
938 done
940 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
943 # Sync remote urls for submodules
944 # This makes the value for remote.$remote.url match the value
945 # specified in .gitmodules.
947 cmd_sync()
949 while test $# -ne 0
951 case "$1" in
952 -q|--quiet)
953 GIT_QUIET=1
954 shift
956 --recursive)
957 recursive=1
958 shift
961 shift
962 break
965 usage
968 break
970 esac
971 done
973 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
976 cmd_absorbgitdirs()
978 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
981 # This loop parses the command line arguments to find the
982 # subcommand name to dispatch. Parsing of the subcommand specific
983 # options are primarily done by the subcommand implementations.
984 # Subcommand specific options such as --branch and --cached are
985 # parsed here as well, for backward compatibility.
987 while test $# != 0 && test -z "$command"
989 case "$1" in
990 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
991 command=$1
993 -q|--quiet)
994 GIT_QUIET=1
996 -b|--branch)
997 case "$2" in
999 usage
1001 esac
1002 branch="$2"; shift
1004 --cached)
1005 cached="$1"
1008 break
1011 usage
1014 break
1016 esac
1017 shift
1018 done
1020 # No command word defaults to "status"
1021 if test -z "$command"
1022 then
1023 if test $# = 0
1024 then
1025 command=status
1026 else
1027 usage
1031 # "-b branch" is accepted only by "add"
1032 if test -n "$branch" && test "$command" != add
1033 then
1034 usage
1037 # "--cached" is accepted only by "status" and "summary"
1038 if test -n "$cached" && test "$command" != status && test "$command" != summary
1039 then
1040 usage
1043 "cmd_$command" "$@"